#<profile4xi profile = "11" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "ipu2sampler4xi5test.py">
#<abstract4xi abstract = "tests ipu2sampler4xi.py"/>
#<verify4xi verification = "11" target = "ipu2sampler4xi.py"/>
#<contextualize4xi context = "sampler4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = "  
__all__ = ['ipu2sampler4xi5test'] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging  
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/> 

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from pipe4xi import Pipe4Xi   
from platformids4xi import get2platformids4xi
from queue4xi import Queue4Xi

# -------------------------------------------------------------------------------------------------
# Command queue module                           
# -------------------------------------------------------------------------------------------------
from ipu2commandqueue4xi import IPU2CommandQueue4Xi
from ipu2commandqueue4xi import create2commandqueue4ipu 
from ipu2commandqueue4xi import flush2commandqueue4ipu
from ipu2commandqueue4xi import finish2commandqueue4ipu
from ipu2commandqueue4xi import get2commandqueueinfo4ipu
from ipu2commandqueue4xi import release2commandqueue4ipu
from ipu2commandqueue4xi import retain2commandqueue4ipu
from ipu2commandqueue4xi import set2commandqueue4ipu
from ipu2commandqueue4xi import trace2commandqueue4ipu

# -------------------------------------------------------------------------------------------------
# Context module                           
# -------------------------------------------------------------------------------------------------
from ipu2context4xi import IPU2Context4Xi 
from ipu2context4xi import create2context4ipu
from ipu2context4xi import get2context4ipu
from ipu2context4xi import release2context4ipu
from ipu2context4xi import retain2context4ipu
from ipu2context4xi import set2context4ipu


# -------------------------------------------------------------------------------------------------
# Device module                        
# -------------------------------------------------------------------------------------------------
from ipu2device4xi import IPU4Xi
from ipu2device4xi import init2ipu4xi 
from ipu2device4xi import set2ipu4xi
from ipu2device4xi import get2ipu4xi


# -------------------------------------------------------------------------------------------------
# Event module                           
# -------------------------------------------------------------------------------------------------
from ipu2event4xi import IPU2Event4Xi
from ipu2event4xi import create2event4ipu
from ipu2event4xi import get2eventinfo4ipu
from ipu2event4xi import release2event4ipu
from ipu2event4xi import retain2event4ipu
from ipu2event4xi import set2eventcallback4ipu 
from ipu2event4xi import set2event4ipu
from ipu2event4xi import trace2event4ipu
from ipu2event4xi import wait2event4ipu

# -------------------------------------------------------------------------------------------------
# Image module                           
# -------------------------------------------------------------------------------------------------
from ipu2image4xi import IPU2Image4Xi
from ipu2image4xi import create2image4ipu
from ipu2image4xi import get2imageinfo4ipu
from ipu2image4xi import get2supportedimageformats4ipu
from ipu2image4xi import manoeuvre2copyimage4ipu
from ipu2image4xi import manoeuvre2copyimagetobuffer4ipu
from ipu2image4xi import manoeuvre2copybuffertoimage4ipu
from ipu2image4xi import manoeuvre2readimage4ipu
from ipu2image4xi import manoeuvre2writeimage4ipu
from ipu2image4xi import manoeuvre2mapimage4ipu
from ipu2image4xi import copy2image4ipu
from ipu2image4xi import copy2imagetobuffer4ipu
from ipu2image4xi import copy2buffertoimage4ipu
from ipu2image4xi import read2image4ipu
from ipu2image4xi import map2image4ipu
from ipu2image4xi import release2image4ipu
from ipu2image4xi import retain2image4ipu
from ipu2image4xi import set2imagecallback4ipu 
from ipu2image4xi import set2image4ipu
from ipu2image4xi import trace2image4ipu
from ipu2image4xi import wait2image4ipu
from ipu2image4xi import write2image4ipu

# -------------------------------------------------------------------------------------------------
# Sampler module                           
# -------------------------------------------------------------------------------------------------
from ipu2sampler4xi import IPU2Sampler4Xi
from ipu2sampler4xi import create2sampler4ipu
from ipu2sampler4xi import get2samplerinfo4ipu
from ipu2sampler4xi import release2sampler4ipu
from ipu2sampler4xi import retain2sampler4ipu
from ipu2sampler4xi import set2samplercallback4ipu 
from ipu2sampler4xi import set2sampler4ipu
from ipu2sampler4xi import trace2sampler4ipu

# -------------------------------------------------------------------------------------------------
# Platform module                           
# -------------------------------------------------------------------------------------------------
from platforminfo4xi import PlatformInfo4Xi                                                                        
from platforminfo4xi import init2platforminfo4xi
from platforminfo4xi import set2platforminfo4xi
from platforminfo4xi import get2platforminfo4xi

# -------------------------------------------------------------------------------------------------
# Trace modules                    
# -------------------------------------------------------------------------------------------------

                                                                                                                  # REMEMBER TO MODIFY NECESSARY MODULES BEFORE TESTS !!
                                                                                                                  
from print4xi import Print4Xi                                                                                     # edit print4xi.py - embeds trace for the functions and classes to be tested
from print4xi import print4xi                                                                                     # see OpenCl4Xi definitions in print4xi.py

from pickle4xi import pickle4xi                                                                                   # edit corresponding pickle2?4xi.py
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi 

    
from actor2a4xi import Actor2a4Xi                                                                                   # define functions and class for zapping 
from actor2b4xi import Actor2b4Xi                                                                                   # not necessary for testing but got to be done later on!
from actor2c4xi import Actor2c4Xi
from actor2d4xi import Actor2d4Xi
from actor2e4xi import Actor2e4Xi
from actor2f4xi import Actor2f4Xi
from actor2g4xi import Actor2g4Xi
from actor2h4xi import Actor2h4Xi
from actor2i4xi import Actor2i4Xi
from actor2j4xi import Actor2j4Xi
from actor2k4xi import Actor2k4Xi
from actor2l4xi import Actor2l4Xi
from actor2m4xi import Actor2m4Xi
from actor2n4xi import Actor2n4Xi
from actor2o4xi import Actor2o4Xi
from actor2p4xi import Actor2p4Xi
from actor2q4xi import Actor2q4Xi
from actor2r4xi import Actor2r4Xi
from actor2s4xi import Actor2s4Xi
from actor2t4xi import Actor2t4Xi
from actor2u4xi import Actor2u4Xi
from actor2v4xi import Actor2v4Xi
from actor2w4xi import Actor2w4Xi
from actor2x4xi import Actor2x4Xi
from actor2y4xi import Actor2y4Xi
from actor2z4xi import Actor2z4Xi
from actor2_4xi import Actor2_4Xi
from time4xi import time4xi                                                                                         # time stamp to events

from xml_trace_sense4xi import xml_trace_sense4xi                                                                   # XML trace
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#" 
#/>


# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

global PickleKB4Xi

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       # 
       'b': Pickle2b4Xi,
       # 
       'c': Pickle2c4Xi,
       # 
       'd': Pickle2d4Xi,
       # 
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
         'IPU2Sampler4Xi':          'NACK4XI',
         'create2sampler4ipu':      'NACK4XI',
         'get2samplerinfo4ipu':     'NACK4XI',
         'retain2sampler4ipu':      'NACK4XI',
         'release2sampler4ipu':     'NACK4XI',
         'trace2sampler4ipu':       'NACK4XI',
         'set2samplercallback4ipu': 'NACK4XI',
         'set2sampler4ipu':         'NACK4XI'  
        }                              
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

#</function4xi>                  

# -------------------------------------------------------------------------------------------------
#<function4xi function = "print-trace4xi" usage = "
#   print XML trace for sampler4ipu test
#"> 
# -------------------------------------------------------------------------------------------------    
def print2trace4xi(t2xi):
       

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\sense-ipu2sampler4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.youripuxi.org/sw4xi/python33/owl/multiprocessing4ipu.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.youripuxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing Sampler of IPU.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Sampler of IPU sensed.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\reason-ipu2sampler4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.youripuxi.org/sw4xi/python33/owl/multiprocessing4ipu.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.youripuxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for Sampler of IPU.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\ace-ipu2sampler4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.youripuxi.org/sw4xi/python33/owl/multiprocessing4ipu.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.youripuxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Sampler of IPU.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of Sampler of IPU.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print2trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "ipu2sampler4xi5test" usage = "
#   tests sampler4ipu
#"> 
# -------------------------------------------------------------------------------------------------    
def ipu2sampler4xi5test():
    global t2xi
    global trace_object_count    
        
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
    
    try:
        # ---------------------------------------------------------------------------------------------
        # START TESTING                          
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 1A/700) OF IPU2SAMPLER4XI5TEST - STARTED ', time4xi()) 
        print('=' *33)   
        # 
                
        # ---------------------------------------------------------------------------------------------
        # PHASE I: FUNCTION TESTS - CREATE SAMPLER WITH FUNCTION                          
        # ---------------------------------------------------------------------------------------------    
        print('(Step 2A/700) OF IPU2SAMPLER4XI5TEST - TRYING TO CREATE SAMPLER4IPU ', time4xi())      
        try:
            response4create2sampler = create2sampler4ipu()                                                                  
            keys2response = response4create2sampler.keys()
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4create2sampler[key2response])
                # ACK2RETURN  :   1D-1E-2C-2B-3B-4B-5B-6B-7B-8B-9B-10B-11B-12B-14B-15B-21A1-22B1-22C1-23B-24B-25B-26B-27B-28B-29B-30B-31B-32B-33B-34B-
                # ADDRESSINGMODE  :  CL_ADDRESS_MIRRORED_REPEAT
                # BUFFER  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, ...
                # CODE2ERROR  :  0
                # COMMANDQUEUE  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK':  ...
                # CONTEXT  :  {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': ...
                # COUNT2REFERENCE  :  1
                # DATA2CALLBACK  :  {'MESSAGE': '{(Step 1Z1/33) failed; create2sampler4ipu-failed ; time: 04:27:49 11/07/11 Pacific Standard Time}', 'CLASS': 'create2sampler4ipu', 'METHOD': 'create2sampler4ipu'}
                # DEVICE  :  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568' ...
                # EVENT  :  {'CODE2ERROR': 0, 'DATA2CALLBACK': ...
                # FILTERINGMODE  :  CL_FILTER_NEAREST
                # FUNCTION2CALLBACK  :  <function trace2sampler4ipu at 0x00000000039A76C8>
                # NACK2RETURN  :   
                # NORMALIZATION  :  CL_TRUE
                # PIPE  :  (<read-write PipeConnection, handle 388>, <read-write PipeConnection, handle 392>)
                # PLATFORM  :  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
                # QUEUE  :  <queue4xi.Queue4Xi object at 0x0000000003B3D0B8>
        except:
            print('(Step 2Z1/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO CREATE SAMPLER4IPU *** ', time4xi())
             
            
        
                        
        # ---------------------------------------------------------------------------------------------
        # PHASE I: FUNCTION TESTS - GET SAMPLER INFO WITH FUNCTION                
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 3B1/700) OF IPU2SAMPLER4XI5TEST - TRYING TO GET SOME SAMPLER INFO FOR IPU ', time4xi())     
        print('=' *33)    
        task4getinfo2sampler = {}
        task4getinfo2sampler ['NORMALIZATION'] = 0
        task4getinfo2sampler ['ADDRESSINGMODE'] = 0
        task4getinfo2sampler ['FILTERINGMODE'] = 0  
        try:
            response4samplerinfo2ipu = get2samplerinfo4ipu(task4getinfo2sampler)                                                                      
            print('(Step 3B2/700) OF IPU2SAMPLER4XI5TEST - GOT SOME SAMPLER INFO FOR IPU ', time4xi())   
            keys2response = response4samplerinfo2ipu.keys()
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4samplerinfo2ipu[key2response])
                # ADDRESSINGMODE  :  CL_ADDRESS_MIRRORED_REPEAT
                # FILTERINGMODE  :  CL_FILTER_NEAREST
                # NORMALIZATION  :  CL_TRUE 
                
        except:
            print('(Step 3Z2/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO GET SOME SAMPLER INFO FOR IPU', time4xi())
        

        
        print('=' *33)          
        print('(Step 3C1/700) OF IPU2SAMPLER4XI5TEST - TRYING TO GET ALL SAMPLER INFO FOR IPU ', time4xi())      
        print('=' *33)       
        try:
            response4getinfo2sampler = get2samplerinfo4ipu()                                                                      
            keys2response = response4getinfo2sampler.keys()
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4getinfo2sampler[key2response])
                # ACK2RETURN  :   1D-1E-2C-2B-3B-4B-5B-6B-7B-8B-9B-10B-11B-12B-14B-15B-21A1-22B1-22C1-23B-24B-25B-26B-27B-28B-29B-30B-31B-32B-33B-34B-
                # ADDRESSINGMODE  :  CL_ADDRESS_MIRRORED_REPEAT
                # BUFFER  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0
                # CODE2ERROR  :  0
                # COMMANDQUEUE  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': 
                # CONTEXT  :  {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': 
                # COUNT2REFERENCE  :  1
                # DATA2CALLBACK  :  {'MESSAGE': '{(Step 1Z1/33) failed; create2sampler4ipu-failed ; time: 04:32:25 11/07/11 Pacific Standard Time}', 'CLASS': 'create2sampler4ipu', 'METHOD': 'create2sampler4ipu'}
                # DEVICE  :  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 
                # EVENT  :  {'CODE2ERROR': 0, 'DATA2CALLBACK': 
                # FILTERINGMODE  :  CL_FILTER_NEAREST
                # FUNCTION2CALLBACK  :  <function trace2sampler4ipu at 0x00000000039676C8>
                # NACK2RETURN  :   
                # NORMALIZATION  :  CL_TRUE
                # PIPE  :  (<read-write PipeConnection, handle 388>, <read-write PipeConnection, handle 392>)
                # PLATFORM  :  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
                # QUEUE  :  <queue4xi.Queue4Xi object at 0x0000000003B020F0>
        except:
            print('(Step 3Z3/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO GET ALL SAMPLER INFO FOR IPU ***', time4xi())
    
                
        # ---------------------------------------------------------------------------------------------
        # PHASE I: FUNCTION TESTS - SET SAMPLER WITH FUNCTION - ALL ATTRIBUTES                          
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 4A/700) OF IPU2SAMPLER4XI5TEST - TRYING TO SET SAMPLER WITH FUNCTION ', time4xi())    
        print('=' *33)
        
        # ---------------------------------------------------------------------------------------------
        # (1) GET PLATFORM IDs TO SET CONTEXT
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 4B/700) OF IPU2SAMPLER4XI5TEST - TRYING TO GET PLATFORMIDS4XI', time4xi())
        print('=' *33)    
        platform2xi = {}
        try:
            platform2xi = get2platformids4xi()
            print('(Step 4B/33) OF IPU2SAMPLER4XI5TEST - GOT PLATFORMIDS4XI', platform2xi) 
            # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1} 
             
        except:
            print('(Step 4Z/33) OF IPU2SAMPLER4XI5TEST *** FAILED TO GET PLATFORMIDS4XI', time4xi())     
    
        # ---------------------------------------------------------------------------------------------
        # (2) INITIALIZE DEVICE                       
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 2A/33) OF IPU2SAMPLER4XI5TEST - TRYING TO INITIALIZE DEVICE4IPU ', time4xi())   
        print('=' *33)        
        try:
            device2ipu = init2ipu4xi()                                                                                
            print('(Step 2B/33) OF IPU2SAMPLER4XI5TEST - INITIALIZED DEVICE4IPU TO: ', device2ipu)        
            # {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568' ...
            
        except:
            print('(Step 2Z/33) OF IPU2SAMPLER4XI5TEST *** FAILED TO INITIALIZE DEVICE4IPU', time4xi()) 
                
            
        # ---------------------------------------------------------------------------------------------
        # (3) CREATE CONTEXT                  
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 3A/700) OF IPU2SAMPLER4XI5TEST - TRYING TO CREATE CONTEXT4IPU ', time4xi())    
        print('=' *33)        
        try:
            context2ipu = create2context4ipu()                                                                            
            print('(Step 3B/700) OF IPU2SAMPLER4XI5TEST - CREATED CONTEXT4IPU: ', context2ipu)                                  
            # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
            
        except:
            print('(Step 3Z/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO CREATE CONTEXT4IPU', time4xi()) 
         
    
              
        # ---------------------------------------------------------------------------------------------
        # (4) INITIALIZE TASK DICTIONARY                         
        # ---------------------------------------------------------------------------------------------            
        task4set2sampler = {}
    
        
        # ---------------------------------------------------------------------------------------------
        # (5) DEFINE CONTEXT - REQUIRED                           
        # ---------------------------------------------------------------------------------------------         
        task4set2sampler  ['CONTEXT'] = context2ipu  
     
        
        # ---------------------------------------------------------------------------------------------
        # (6) DEFINE DEVICE - EXTRA                          
        # ---------------------------------------------------------------------------------------------         
        task4set2sampler  ['DEVICE'] = device2ipu  
    
        # ---------------------------------------------------------------------------------------------
        # (7) DEFINE PROPERTIES - NONE                           
        # ---------------------------------------------------------------------------------------------         
        task4set2sampler  ['PROPERTIES'] = None 
    
        
        # ---------------------------------------------------------------------------------------------
        # (8) DEFINE ERROR CODE - REQUIRED                            
        # ---------------------------------------------------------------------------------------------         
        task4set2sampler  ['CODE2ERROR'] = 0 
    
        
        # ---------------------------------------------------------------------------------------------
        # (9) SET QUEUE - EXTRA                            
        # ---------------------------------------------------------------------------------------------         
        task4set2sampler ['QUEUE'] = None
        print('(Step 9A/700) OF IPU2SAMPLER4XI5TEST - TRYING TO SET QUEUE FOR SAMPLER4IPU ', time4xi())   
        try:                               
            task4set2sampler ['QUEUE'] = Queue4Xi()                                                                                                                    
            print('(Step 9B/700) OF IPU2SAMPLER4XI5TEST - QUEUE OF SAMPLER4IPU: ', task4set2sampler ['QUEUE'])                           
            # <queue4xi.Queue4Xi object at 0x0000000003B050F0>
            
        except:
            print('(Step 9Z/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO SET QUEUE FOR SAMPLER4IPU ', time4xi())  
                     
        
        # ---------------------------------------------------------------------------------------------
        # (10) SET PIPE - EXTRA                            
        # ---------------------------------------------------------------------------------------------         
        task4set2sampler ['PIPE'] = None
        print('(Step 10A/700) OF IPU2SAMPLER4XI5TEST - TRYING TO SET PIPE FOR SAMPLER4IPU ', time4xi())    
        try:                               
            task4set2sampler ['PIPE'] = Pipe4Xi()                                                                                                                    
            print('(Step 10B/700) OF IPU2SAMPLER4XI5TEST - PIPE OF SAMPLER4IPU: ', task4set2sampler ['PIPE'])                           
            # (<read-write PipeConnection, handle 520>, <read-write PipeConnection, handle 524>)  
            
        except:
            print('(Step 10Z/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO SET PIPE FOR SAMPLER4IPU ', time4xi())  
    
        
        # ---------------------------------------------------------------------------------------------
        # (11) SET REST                            
        # ---------------------------------------------------------------------------------------------         
        task4set2sampler ['COMMANDQUEUE'] = None
        print('(Step 11A/700) OF IPU2SAMPLER4XI5TEST - TRYING TO SET COMMAND QUEUE FOR SAMPLER4IPU ', time4xi())    
        try:                               
            task4set2sampler ['COMMANDQUEUE'] = create2commandqueue4ipu()                                                                                                                    
            print('(Step 11B/700) OF IPU2SAMPLER4XI5TEST - COMMAND QUEUE OF SAMPLER4IPU: ', task4set2sampler ['COMMANDQUEUE'])                           
            # 
            task4set2sampler ['NORMALIZATION'] = 'CL_TRUE'                                                                                                                 
            print('(Step 11C/700) OF IPU2SAMPLER4XI5TEST - NORMALIZATION OF SAMPLER4IPU: ', task4set2sampler ['NORMALIZATION'])                           
            # 
            task4set2sampler ['ADDRESSINGMODE'] = 'CL_ADDRESS_REPEAT'                                                                                                                    
            print('(Step 11D/700) OF IPU2SAMPLER4XI5TEST - ADDRESSINGMODE OF SAMPLER4IPU: ', task4set2sampler ['ADDRESSINGMODE'])                           
            #
            task4set2sampler ['FILTERINGMODE'] = 'CL_FILTER_NEAREST'                                                                                                                   
            print('(Step 11E/700) OF IPU2SAMPLER4XI5TEST - FILTERINGMODE OF SAMPLER4IPU: ', task4set2sampler ['FILTERINGMODE'])                           
            #                
            
        except:
            print('(Step 11Z1/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO SET COMMAND QUEUE FOR SAMPLER4IPU ', time4xi())  
                                                  

                
        # ---------------------------------------------------------------------------------------------
        # (11) SET SAMPLER - FINALLY!                           
        # ---------------------------------------------------------------------------------------------          
        response4set2sampler = {} 
        print('(Step 11F/700) OF IPU2SAMPLER4XI5TEST - TRYING TO SET SAMPLER4IPU ', time4xi())   
        try:                               
            response4set2sampler = set2sampler4ipu(task4set2sampler)                                                                                                         
    
            keys2response = response4set2sampler.keys()
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4set2sampler[key2response])
                # ACK2RETURN  :   23B-24B-25B-26B-27B-28B-31B-32B-33B-
                # ADDRESSINGMODE  :  CL_ADDRESS_REPEAT
                # BUFFER  :  {'CODE2ERROR': 0 ...
                # CODE2ERROR  :  0
                # COMMANDQUEUE  :  {'CODE2ERROR': 0, ...
                # CONTEXT  :  {'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
                # COUNT2REFERENCE  :  1
                # DATA2CALLBACK  :  {'MESSAGE': '{(Step 1Z1/33) failed; create2sampler4ipu-failed ; time: 22:37:25 11/07/11 Pacific Standard Time}', 'CLASS': 'create2sampler4ipu', 'METHOD': 'create2sampler4ipu'}
                # DEVICE  :  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568' ...
                # EVENT  :  {'CODE2ERROR': 0, 'DATA2CALLBACK': ...
                # FILTERINGMODE  :  CL_FILTER_NEAREST
                # FUNCTION2CALLBACK  :  <function trace2sampler4ipu at 0x00000000038CF5C8>
                # NACK2RETURN  :   21Z1-22Z2-22Z3-29Z1-30Z1-34Z1-
                # NORMALIZATION  :  CL_TRUE
                # PIPE  :  (<read-write PipeConnection, handle 520>, <read-write PipeConnection, handle 524>)
                # PLATFORM  :  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
                # QUEUE  :  <queue4xi.Queue4Xi object at 0x0000000003B53B00>
                
                
        except:
            print('(Step 11Z2/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO SET SAMPLER4IPU *** ', time4xi())  
            
        
        # ---------------------------------------------------------------------------------------------
        # (12) REFERENCE COUNT FOR EACH PROCESSING UNIT RELEASED BY DECREMENTING COUNT WITH 1             
        # ---------------------------------------------------------------------------------------------    
    
        task4release2sampler  = {} 
        task4release2sampler  ['COUNT2REFERENCE'] = 1 
        response4release2sampler = {}
        
        print('(Step 12A/700) OF IPU2SAMPLER4XI5TEST - TRYING TO RELEASE SAMPLER OF IPU DEVICE ', time4xi())    
        # 
        try:                               
            response4release2sampler = release2sampler4ipu(task4release2sampler)                                                                                             
                             
            keys2response = response4release2sampler.keys()
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4release2sampler[key2response])
                # COUNT2REFERENCE  :  0
            
        except:
            print('(Step 12Z1/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO RELEASE SAMPLER OF IPU DEVICE ', time4xi())  
        
        task4getinfo2sampler = {}
        task4getinfo2sampler ['COUNT2REFERENCE'] = 0
    
        print('(Step 12C/700) OF IPU2SAMPLER4XI5TEST - TRYING TO GET SELECTED SAMPLER INFO OF IPU DEVICE ', time4xi())     
        # 
        try:                               
            response4getinfo2sampler = get2samplerinfo4ipu (task4getinfo2sampler)                                                                                             
            keys2response = response4getinfo2sampler.keys()
    
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4getinfo2sampler[key2response])
                # COUNT2REFERENCE  :  0
                
        except:
            print('(Step 12Z2/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO GET SELECTED SAMPLER INFO OF IPU DEVICE ', time4xi())  
                                    
        
        # ---------------------------------------------------------------------------------------------
        # (13) REFERENCE COUNT FOR EACH PROCESSING UNIT RETAINED BY INCREMENTING COUNT WITH 1             
        # ---------------------------------------------------------------------------------------------    
        task4retain2sampler  = {}
        task4retain2sampler  ['COUNT2REFERENCE'] = 1 
        response4retain2sampler = {}
        print('(Step 13A/700) OF IPU2SAMPLER4XI5TEST - TRYING TO RETAIN SAMPLER OF IPU DEVICE ', time4xi())   
        try:                               
            response4retain2sampler = retain2sampler4ipu(task4retain2sampler)                                                                                                 
                           
            keys2response = response4retain2sampler.keys()
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4retain2sampler[key2response])
                # COUNT2REFERENCE  :  1
                
        except:
            print('(Step 13Z1/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO RETAIN SAMPLER OF IPU DEVICE ', time4xi()) 
        
               
    
        # ---------------------------------------------------------------------------------------------
        # (14) SAMPLER CALLBACK            
        # ---------------------------------------------------------------------------------------------    
        
        print('(Step 14A/700) OF IPU2SAMPLER4XI5TEST - TRYING TO SET SAMPLER CALLBACK OF IPU ', time4xi())  
        try:                               
            response4setcallback2sampler = set2samplercallback4ipu()                                                                                                 
            print('(Step 14B/700) OF IPU2SAMPLER4XI5TEST - SET SAMPLER CALLBACK OF IPU TO: ', response4setcallback2sampler)   
            # <function trace2sampler4ipu at 0x00000000039676C8>
        except:
            print('(Step 14Z1/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO SET SAMPLER CALLBACK OF IPU ', time4xi())  
    
                                                                                                              
        # ---------------------------------------------------------------------------------------------
        # PHASE I: TRACE FUNCTION TESTS                    
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 15A/25) OF IPU2SAMPLER4XI5TEST - TRYING TO TRACE IPU: ', time4xi())      
        print('=' *33)      
        trace2ipu = None
        try:
            trace2ipu = trace2sampler4ipu() 
            print('(Step 15B/25) OF IPU2SAMPLER4XI5TEST - TRACE2IPU: ', trace2ipu)  
            # {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4ipu-failed {}; time: 04:32:25 11/07/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4ipu', 'METHOD': 'trace2sampler4ipu'} 
    
        except:
            print('(Step 15Z1/25) OF IPU2SAMPLER4XI5TEST *** FAILED TO TRACE IPU: ', trace2ipu)     
                                                                                                              
    
                                                                                                                                                     
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS                          
        # ---------------------------------------------------------------------------------------------
        print('=' *33)          
        print('(Step 105A/700) OF IPU2SAMPLER4XI5TEST - CREATING SAMPLER4IPU OBJECT ', time4xi())     
        print('=' *33)  
        # 
        try:
            # ---------------------------------------------------------------------------------------------
            # CREATE WITH OBJECT                        
            # ---------------------------------------------------------------------------------------------        
            samplerobject2ipu = IPU2Sampler4Xi()
            print('(Step 105B/700) OF IPU2SAMPLER4XI5TEST - CREATED SAMPLER4IPU OBJECT: ', samplerobject2ipu)                                  
            # <ipu2sampler4xi.IPU2Sampler4Xi object at 0x0000000003B02320>
            
        except:
            print('(Step 105Z/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO CREATE SAMPLER4IPU OBJECT')
        
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - GET METHOD                  
        # ---------------------------------------------------------------------------------------------          
        print('(Step 106A1/700) OF IPU2SAMPLER4XI5TEST - TRYING TO GET SAMPLER INFO ', time4xi())    
        try:                               
            response4get2samplerinfo = samplerobject2ipu.get2samplerinfo()                                 
                                     
            keys2response = response4get2samplerinfo.keys()
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4get2samplerinfo[key2response])
                # ACK2RETURN  :   1D-1E-2C-2B-3B-4B-5B-6B-7B-8B-9B-10B-11B-12B-14B-15B-21A1-22B1-22C1-23B-24B-25B-26B-27B-28B-29B-30B-31B-32B-33B-34B-
                # ADDRESSINGMODE  :  CL_ADDRESS_MIRRORED_REPEAT
                # BUFFER  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
                # CODE2ERROR  :  0
                # COMMANDQUEUE  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0
                # CONTEXT  :  {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': 
                # COUNT2REFERENCE  :  1
                # DATA2CALLBACK  :  {'MESSAGE': '{(Step 1Z1/33) failed; create2sampler4ipu-failed ; time: 04:32:25 11/07/11 Pacific Standard Time}', 'CLASS': 'create2sampler4ipu', 'METHOD': 'create2sampler4ipu'}
                # DEVICE  :  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568'
                # EVENT  :  {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4ipu-failed ; time: 04:32:25 11/07/11 Pacific Standard Time}', 
                # FILTERINGMODE  :  CL_FILTER_NEAREST
                # FUNCTION2CALLBACK  :  <function trace2sampler4ipu at 0x00000000039676C8>
                # NACK2RETURN  :   
                # NORMALIZATION  :  CL_TRUE
                # PIPE  :  (<read-write PipeConnection, handle 412>, <read-write PipeConnection, handle 416>)
                # PLATFORM  :  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
                # QUEUE  :  <queue4xi.Queue4Xi object at 0x0000000003B02F98>
                # (Step 106A2/700) OF IPU2SAMPLER4XI5TEST - TRYING TO GET SELECTED SAMPLER INFO OF IPU DEVICE  04:32:25 11/07/11 Pacific Standard Time
                # ADDRESSINGMODE  :  CL_ADDRESS_MIRRORED_REPEAT
                # COUNT2REFERENCE  :  1
                # FILTERINGMODE  :  CL_FILTER_NEAREST
                # NORMALIZATION  :  CL_TRUE
                
        except:
            print('(Step 106Z1/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO GET SAMPLER INFO ', time4xi()) 
        
        task4getinfo2sampler = {}
        task4getinfo2sampler ['NORMALIZATION'] = 0
        task4getinfo2sampler ['ADDRESSINGMODE'] = 0
        task4getinfo2sampler ['FILTERINGMODE'] = 0
        task4getinfo2sampler ['COUNT2REFERENCE'] = 0
        response4getinfo2sampler = {}
        print('(Step 106A2/700) OF IPU2SAMPLER4XI5TEST - TRYING TO GET SELECTED SAMPLER INFO OF IPU DEVICE ', time4xi())    
        # 
        try:                               
            response4getinfo2sampler = samplerobject2ipu.get2samplerinfo(task4getinfo2sampler)                                                                                             
            keys2response = response4getinfo2sampler.keys()
    
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4getinfo2sampler[key2response])
                # ADDRESSINGMODE  :  CL_ADDRESS_MIRRORED_REPEAT
                # COUNT2REFERENCE  :  1
                # FILTERINGMODE  :  CL_FILTER_NEAREST
                # NORMALIZATION  :  CL_TRUE 
                
        except:
            print('(Step 106Z2/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO GET SELECTED SAMPLER INFO OF IPU DEVICE ', time4xi()) 
                       
        
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - SET METHOD            
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 107A/700) OF IPU2SAMPLER4XI5TEST - TRYING TO SET SAMPLER ', time4xi())
        print('=' *33)       
        # 
              
        # ---------------------------------------------------------------------------------------------
        # (4) INITIALIZE TASK DICTIONARY                         
        # ---------------------------------------------------------------------------------------------            
        task4set2sampler = {}
    
    
        # ---------------------------------------------------------------------------------------------
        # (5) DEFINE CONTEXT - REQUIRED                           
        # ---------------------------------------------------------------------------------------------         
    
        task4set2sampler  ['CONTEXT'] = context2ipu  
    
        
        # ---------------------------------------------------------------------------------------------
        # (6) DEFINE DEVICE - EXTRA                           
        # ---------------------------------------------------------------------------------------------         
    
        task4set2sampler  ['DEVICE'] = device2ipu  
                          
    
        # ---------------------------------------------------------------------------------------------
        # (7) DEFINE ERROR CODE - REQUIRED                            
        # ---------------------------------------------------------------------------------------------         
        task4set2sampler  ['CODE2ERROR'] = 0 
    
        
        # ---------------------------------------------------------------------------------------------
        # (8) QUEUE - EXTRA                            
        # ---------------------------------------------------------------------------------------------         
        print('(Step 108A/700) OF IPU2SAMPLER4XI5TEST - TRYING TO SET QUEUE4XI ', time4xi()) 
        task4set2sampler  ['QUEUE'] = None
        try:
            task4set2sampler  ['QUEUE'] = Queue4Xi() 
            print('(Step 108B/700) OF IPU2SAMPLER4XI5TEST - QUEUE : ', task4set2sampler  ['QUEUE']) 
            # <queue4xi.Queue4Xi object at 0x0000000003B02B00>
            
        except:
            print('(Step 108Z1/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO CREATE QUEUE4XI ', time4xi()) 
                
        # ---------------------------------------------------------------------------------------------
        # (9) PIPE                           
        # ---------------------------------------------------------------------------------------------         
        print('(Step 109A/700) OF IPU2SAMPLER4XI5TEST - TRYING TO SET PIPE4XI ', time4xi()) 
        task4set2sampler  ['PIPE'] = None
        try:
            task4set2sampler  ['PIPE'] = Pipe4Xi() 
            print('(Step 109B/700) OF IPU2SAMPLER4XI5TEST - PIPE : ', task4set2sampler  ['PIPE'])
            # (<read-write PipeConnection, handle 380>, <read-write PipeConnection, handle 384>)
            
        except:
            print('(Step 109Z/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO SET PIPE4XI ', time4xi()) 
        
        # ---------------------------------------------------------------------------------------------
        # (10) SET COMMAND QUEUE - EXTRA                            
        # ---------------------------------------------------------------------------------------------         
        task4set2sampler ['COMMANDQUEUE'] = None
        print('(Step 110A/700) OF IPU2SAMPLER4XI5TEST - TRYING TO SET COMMAND QUEUEFOR SAMPLER4IPU ', time4xi())   
        try:                               
            task4set2sampler ['COMMANDQUEUE'] = create2commandqueue4ipu()                                                                                                                    
            print('(Step 110B/700) OF IPU2SAMPLER4XI5TEST - COMMAND QUEUE OF SAMPLER4IPU: ', task4set2sampler ['COMMANDQUEUE'])                           
            # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0
            
            
        except:
            print('(Step 110Z/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO SET COMMAND QUEUE FOR SAMPLER4IPU ', time4xi())
              
        # ---------------------------------------------------------------------------------------------
        # (11) SET ADDRESSINGMODE - EXTRA                            
        # ---------------------------------------------------------------------------------------------         
        
        print('(Step 111A/700) OF IPU2SAMPLER4XI5TEST - TRYING TO SET ADDRESSINGMODEFOR SAMPLER4IPU ', time4xi())   
        try:                               
            task4set2sampler ['ADDRESSINGMODE'] = 'CL_ADDRESS_CLAMP_TO_EDGE'                                                                                                                  
            print('(Step 111B/700) OF IPU2SAMPLER4XI5TEST - ADDRESSINGMODE OF SAMPLER4IPU: ', task4set2sampler ['ADDRESSINGMODE'])                           
            # CL_ADDRESS_CLAMP_TO_EDGE
            
            
        except:
            print('(Step 111Z/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO SET ADDRESSINGMODE FOR SAMPLER4IPU ', time4xi())  
            
        
        # ---------------------------------------------------------------------------------------------
        # (12) SET FILTERINGMODE - EXTRA                            
        # ---------------------------------------------------------------------------------------------         
        
        print('(Step 121A/700) OF IPU2SAMPLER4XI5TEST - TRYING TO SET FILTERINGMODEFOR SAMPLER4IPU ', time4xi())   
        try:                               
            task4set2sampler ['FILTERINGMODE'] = 'CL_FILTER_LINEAR'                                                                                                                  
            print('(Step 121B/700) OF IPU2SAMPLER4XI5TEST - FILTERINGMODE OF SAMPLER4IPU: ', task4set2sampler ['FILTERINGMODE'])                           
            # CL_FILTER_LINEAR
            
            
        except:
            print('(Step 121Z/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO SET FILTERINGMODE FOR SAMPLER4IPU ', time4xi())           
            
            
                                                        
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - SET SAMPLER WITH METHOD                  
        # ---------------------------------------------------------------------------------------------     
        print('(Step 111A/700) OF IPU2SAMPLER4XI5TEST - TRYING TO SET SAMPLER FOR IPU: ', time4xi())      
        try: 
            response4set2sampler = samplerobject2ipu.set2sampler(task4set2sampler)                                                       
            keys2response = response4set2sampler.keys()
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4set2sampler[key2response])
                # ACK2RETURN  :   23B-24B-25B-26B-27B-28B-32B-33B-
                # ADDRESSINGMODE  :  CL_ADDRESS_CLAMP_TO_EDGE
                # BUFFER  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0
                # CODE2ERROR  :  0
                # COMMANDQUEUE  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0
                # CONTEXT  :  {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': 
                # COUNT2REFERENCE  :  1
                # DATA2CALLBACK  :  {'MESSAGE': '{(Step 1Z1/33) failed; create2sampler4ipu-failed ; time: 04:32:25 11/07/11 Pacific Standard Time}', 'CLASS': 'create2sampler4ipu', 'METHOD': 'create2sampler4ipu'}
                # DEVICE  :  {'RESOLUTION2TIMER4PROFILING': 318
                # EVENT  :  {'CODE2ERROR': 0, 'DATA2CALLBACK': 
                # FILTERINGMODE  :  CL_FILTER_LINEAR
                # FUNCTION2CALLBACK  :  <function trace2sampler4ipu at 0x00000000039676C8>
                # NACK2RETURN  :   21Z1-22Z2-22Z3-29Z1-30Z1-31Z1-34Z1-
                # NORMALIZATION  :  CL_TRUE
                # PIPE  :  (<read-write PipeConnection, handle 380>, <read-write PipeConnection, handle 384>)
                # PLATFORM  :  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
                # QUEUE  :  <queue4xi.Queue4Xi object at 0x0000000003B02B00>
            
        except:
            print('(Step 111Z/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO SET SAMPLER FOR IPU: ', time4xi()) 
            
    
                                                                                     
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - RELEASE SAMPLER                           
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 121A/700) OF IPU2SAMPLER4XI5TEST - RELEASING SAMPLER', time4xi())  
        print('=' *33)      
        # 
        task4release2sampler  = {}
        task4release2sampler  ['COUNT2REFERENCE'] = 1
        try:
            response4release2sampler = samplerobject2ipu.release2sampler(task4release2sampler)
            keys2response = response4release2sampler.keys()
    
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4release2sampler[key2response])
                # COUNT2REFERENCE  :  0
                
        except:
            print('(Step 121Z/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO RELEASE SAMPLER', time4xi())  
            
                                                                                       
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - RETAIN SAMPLER                           
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 122A/700) OF IPU2SAMPLER4XI5TEST - RETAINING SAMPLER ', time4xi())
        print('=' *33)      
        task4retain2sampler  = {}
        task4retain2sampler  ['COUNT2REFERENCE'] = 1
        try:
            response4retain2sampler = samplerobject2ipu.retain2sampler(task4retain2sampler)
            keys2response = response4retain2sampler.keys()
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4retain2sampler[key2response])
                # COUNT2REFERENCE  :  1
                
        except:
            print('(Step 122Z/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO RETAIN SAMPLER ', time4xi())
                       
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - CREATE AGAIN SAMPLER OBJECT AND USE ITS CREATE METHOD                           
        # ---------------------------------------------------------------------------------------------        
        print('(Step 123A/700) OF IPU2SAMPLER4XI5TEST - TRYING TO CREATE SAMPLER for IPU ', time4xi()) 
        # 
        try:
            xi2ipu = IPU2Sampler4Xi()                            
            response4create2sampler = xi2ipu.create2sampler()                                  
            keys2response = response4create2sampler.keys()
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4create2sampler[key2response])
                # ACK2RETURN  :   1D-1E-2C-2B-3B-4B-5B-6B-7B-8B-9B-10B-11B-12B-14B-15B-21A1-22B1-22C1-23B-24B-25B-26B-27B-28B-29B-30B-31B-32B-33B-34B-
                # ADDRESSINGMODE  :  CL_ADDRESS_MIRRORED_REPEAT
                # BUFFER  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0
                # CODE2ERROR  :  0
                # COMMANDQUEUE  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0
                # CONTEXT  :  {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': 
                # COUNT2REFERENCE  :  1
                # DATA2CALLBACK  :  {'MESSAGE': '{(Step 1Z1/33) failed; create2sampler4ipu-failed ; time: 04:32:25 11/07/11 Pacific Standard Time}', 'CLASS': 'create2sampler4ipu', 'METHOD': 'create2sampler4ipu'}
                # DEVICE  :  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568'
                # EVENT  :  {'CODE2ERROR': 0, 'DATA2CALLBACK': 
                # FILTERINGMODE  :  CL_FILTER_NEAREST
                # FUNCTION2CALLBACK  :  <function trace2sampler4ipu at 0x00000000039676C8>
                # NACK2RETURN  :   
                # NORMALIZATION  :  CL_TRUE
                # PIPE  :  (<read-write PipeConnection, handle 408>, <read-write PipeConnection, handle 424>)
                # PLATFORM  :  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
                # QUEUE  :  <queue4xi.Queue4Xi object at 0x0000000003B02E48>
                
        except:
            print('(Step 123Z/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO CREATE SAMPLER for IPU ', time4xi())             
                       
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - SET SAMPLER CALLBACK WITH METHOD                           
        # ---------------------------------------------------------------------------------------------        
        print('(Step 124A/700) OF IPU2SAMPLER4XI5TEST - TRYING TO SET SAMPLER CALLBACK WITH METHOD OF OBJECT XI2IPU: ', xi2ipu) 
        # 
        try:
                             
            callback2ipu = xi2ipu.set2samplercallback()                                  
            print('(Step 124B/700) OF IPU2SAMPLER4XI5TEST - SET SAMPLER WITH CALLBACK TO: ', callback2ipu)
            # <function trace2sampler4ipu at 0x00000000039676C8> 
                              
        except:
            print('(Step 124Z/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO SET SAMPLER CALLBACK WITH METHOD ***', time4xi())                  
    
                                                                                                              
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - TRACE SAMPLERS                           
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 125A/25) OF IPU2SAMPLER4XI5TEST - TRYING TO TRACE IPU: ', time4xi())      
        print('=' *33)      
        # 
        
        trace2ipu = None
        try:
            trace2ipu = xi2ipu.trace2sampler() 
        
            print('=' *33)          
            print('(Step 125B/25) OF IPU2SAMPLER4XI5TEST - TRACE2IPU: ', trace2ipu)  
            # {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4ipu-failed {}; time: 04:32:25 11/07/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4ipu', 'METHOD': 'trace2sampler4ipu'}
    
            
            print('=' *33)
        except:
            print('(Step 125Z1/25) OF IPU2SAMPLER4XI5TEST *** FAILED TO TRACE IPU: ', trace2ipu)     
                                                                                                              
    
        
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - RELEASE SAMPLER BY DECREMENTING REFERENCE COUNT WITH 1             
        # ---------------------------------------------------------------------------------------------    
        task4release2sampler  = {} 
        task4release2sampler  ['COUNT2REFERENCE'] = 1 
        response4release2sampler = {}
       
        print('(Step 133A/700) OF IPU2SAMPLER4XI5TEST - TRYING TO RELEASE SAMPLER OF IPU DEVICE ', time4xi())    
        # 
        try:                               
            response4release2sampler = xi2ipu.release2sampler(task4release2sampler)                                                                                             
                            
            keys2response = response4release2sampler.keys()
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4release2sampler[key2response])
                # COUNT2REFERENCE  :  0
        except:
            print('(Step 133Z1/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO RELEASE SAMPLER OF IPU DEVICE ', time4xi())  
        
        task4getinfo2sampler = {}
        task4getinfo2sampler ['COUNT2REFERENCE'] = 0
        response4getinfo2sampler = {}
        print('(Step 133C/700) OF IPU2SAMPLER4XI5TEST - TRYING TO GET SELECTED SAMPLER INFO OF IPU DEVICE ', time4xi())     
        # 
        try:                               
            response4getinfo2sampler = xi2ipu.get2samplerinfo (task4getinfo2sampler)                                                                                             
            keys2response = response4getinfo2sampler.keys()
     
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4getinfo2sampler[key2response])
                # COUNT2REFERENCE  :  0
        except:
            print('(Step 133Z2/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO GET SELECTED SAMPLER INFO OF IPU DEVICE ', time4xi())  
                                    
        
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - RETAIN SAMPLER BY DECREASING REFERENCE WITH 1             
        # ---------------------------------------------------------------------------------------------    
        task4retain2sampler  = {}
        task4retain2sampler  ['COUNT2REFERENCE'] = 1 
        response4retain2sampler = {}
        print('(Step 134A/700) OF IPU2SAMPLER4XI5TEST - TRYING TO RETAIN SAMPLER OF IPU DEVICE ', time4xi())   
        try:                               
            response4retain2sampler = xi2ipu.retain2sampler(task4retain2sampler)                                                                                                 
                           
            keys2response = response4retain2sampler.keys()
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4retain2sampler[key2response])
                # COUNT2REFERENCE  :  1
        except:
            print('(Step 134Z1/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO RETAIN SAMPLER OF IPU DEVICE ', time4xi())
            
        task4getinfo2sampler = {}
        task4getinfo2sampler ['COUNT2REFERENCE'] = 0
        response4getinfo2sampler = {}
        print('(Step 134C/700) OF IPU2SAMPLER4XI5TEST - TRYING TO GET SELECTED SAMPLER INFO OF IPU DEVICE ', time4xi())     
        # 
        try:                               
            response4getinfo2sampler = xi2ipu.get2samplerinfo (task4getinfo2sampler)                                                                                             
            keys2response = response4getinfo2sampler.keys()
      
            for key2response in sorted(keys2response):
                print(key2response, ' : ', response4getinfo2sampler[key2response])
                # COUNT2REFERENCE  :  1
                
        except:
            print('(Step 134Z2/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO GET SELECTED SAMPLER INFO OF IPU DEVICE ', time4xi())         
                                                            
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - SENSE SAMPLER                           
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 170A/700) OF IPU2SAMPLER4XI5TEST - SENSING ', time4xi())  
        print('=' *33)      
        
        try:
            print(xi2ipu.sense())
        
            print('=' *33)          
            print('(Step 170B/700) OF IPU2SAMPLER4XI5TEST - SENSED ', time4xi()) 
            # {'classvariable2ipu-of-IPU2Sampler4Xi': 4, 'object': <ipu2sampler4xi.IPU2Sampler4Xi object at 0x0000000003B02F98>}
            
            print('=' *33)
        except:
            print('(Step 170Z/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO SENSE ', time4xi())          
            
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - REASON SAMPLER                           
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 171A/700) OF IPU2SAMPLER4XI5TEST - REASONING ', time4xi())
        print('=' *33)       
        
        try:
            print(xi2ipu.reason())
        
            print('=' *33)          
            print('(Step 171B/700) OF IPU2SAMPLER4XI5TEST - REASONED ', time4xi())
            # {'object-reason-object4xi': <ipu2sampler4xi.IPU2Sampler4Xi object at 0x0000000003B02F98>, 'time-reason-of-IPU2Sampler4Xi': '04:32:25 11/07/11 Pacific Standard Time'}
            
            print('=' *33)       
        except:
            print('(Step 171Z/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO REASON ', time4xi())                                   
                 
        # ---------------------------------------------------------------------------------------------
        # PHASE II: CLASS TESTS - ACE SAMPLER                           
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 172A/700) OF IPU2SAMPLER4XI5TEST - ACING ', time4xi())   
        print('=' *33)       
        
        try:
            print(xi2ipu.ace())
        
            print('=' *33)          
            print('(Step 172B/700) OF IPU2SAMPLER4XI5TEST - ACED ', time4xi())                                                 
            # {'cores-of-IPU2Sampler4Xi': 4, 'object8xi': <ipu2sampler4xi.IPU2Sampler4Xi object at 0x0000000003B02F98>} 
            
            print('=' *33) 
        except:
            print('(Step 172Z/700) OF IPU2SAMPLER4XI5TEST *** FAILED TO ACE ', time4xi())                                       
         
        # ---------------------------------------------------------------------------------------------
        # DONE - ALL TESTS                          
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('(Step 174/700) OF IPU2SAMPLER4XI5TEST - DONE! ', time4xi())
        #                         
        print('=' *33) 
    except:
        print('(Step 175/700) OF IPU2SAMPLER4XI5TEST *** FAILED ****  ', time4xi())
    finally:            
        # ---------------------------------------------------------------------------------------------    
        # Print Trace
        # ---------------------------------------------------------------------------------------------     
        print2trace4xi(t2xi)        
           
      
#</function4xi>            
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   main function for ipu2sampler4xi5test
#"> 
# -------------------------------------------------------------------------------------------------    
def main():
       
    print('=' *33)
    print("(Step 0A/700) OF IPU2SAMPLER4XI5TEST - SENSING IT WITH YOURIPUXI!", time4xi())   
    # 
    print('=' *33)
        
    ipu2sampler4xi5test()  
    
    print('=' *33)
    print("(Step 0B/700) OF IPU2SAMPLER4XI5TEST - SENSED IT WITH YOURIPUXI!", time4xi()) 
    # 
       
    print('=' *33) 
                          
#</function4xi>
     

# -------------------------------------------------------------------------------------------------
# __main__                              
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
#</program4xi>
 

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# ipu2sampler4xi5test.txt
# sense-ipu2sampler4xi5test.xml
# reason-ipu2sampler4xi5test.xml
# ace-ipu2sampler4xi5test.xml
#" 
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>

# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# nothing
#"
#/>

#<note4xi note = "
# parse4xi.py - to parse this module
# "/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of ipu2sampler4xi5test.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/> 
